*** libapache-mod-auth-kerb-5.3-origdeb/src/mod_auth_kerb.c	2006-11-22 11:32:58.000000000 +0100
--- libapache-mod-auth-kerb-5.3/src/mod_auth_kerb.c	2007-08-08 23:34:43.000000000 +0200
***************
*** 158,163 ****
--- 158,164 ----
  	const char *krb_service_name;
  	int krb_authoritative;
  	int krb_delegate_basic;
+ 	int krb_append_realm;
  #if 0
  	int krb_ssl_preauthentication;
  #endif
***************
*** 212,217 ****
--- 213,220 ----
  
     command("KrbDelegateBasic", ap_set_flag_slot, krb_delegate_basic,
       FLAG, "Always offer Basic authentication regardless of KrbMethodK5Pass and pass on authentication to lower modules if Basic headers arrive."),
+    command("KrbAppendRealm", ap_set_flag_slot, krb_append_realm,
+      FLAG, "Append the realm name when setting $REMOTE_USER."),
  
  #if 0
     command("KrbEnableSSLPreauthentication", ap_set_flag_slot, krb_ssl_preauthentication,
***************
*** 316,321 ****
--- 319,325 ----
  	((kerb_auth_config *)rec)->krb_service_name = NULL;
  	((kerb_auth_config *)rec)->krb_authoritative = 1;
  	((kerb_auth_config *)rec)->krb_delegate_basic = 0;
+ 	((kerb_auth_config *)rec)->krb_append_realm = 0;
  #if 0
  	((kerb_auth_config *)rec)->krb_ssl_preauthentication = 0;
  #endif
***************
*** 514,520 ****
     user = apr_pstrdup(r->pool, sent_name);
     if (sent_instance)
        user = apr_pstrcat(r->pool, user, ".", sent_instance, NULL);
!    user = apr_pstrcat(r->pool, user, "@", realm, NULL);
  
     MK_USER = user;
     MK_AUTH_TYPE = "Basic";
--- 518,527 ----
     user = apr_pstrdup(r->pool, sent_name);
     if (sent_instance)
        user = apr_pstrcat(r->pool, user, ".", sent_instance, NULL);
! 
!    if (conf->krb_append_realm)
!       user = ap_pstrcat(r->pool, user, "@", realm, NULL);
! 
  
     MK_USER = user;
     MK_AUTH_TYPE = "Basic";
***************
*** 1010,1015 ****
--- 1017,1025 ----
     MK_AUTH_TYPE = "Basic";
     free(name);
  
+    if (!conf->krb_append_realm && (name = strchr(MK_USER, '@')))
+       *name = '\0';
+ 
     if (conf->krb_save_credentials)
        store_krb5_creds(kcontext, r, conf, ccache);
  
***************
*** 1258,1263 ****
--- 1268,1274 ----
    gss_OID_desc spnego_oid;
    gss_ctx_id_t context = GSS_C_NO_CONTEXT;
    gss_cred_id_t server_creds = GSS_C_NO_CREDENTIAL;
+   char            *name = NULL;
  
    *negotiate_ret_value = "\0";
  
***************
*** 1391,1396 ****
--- 1402,1411 ----
    MK_AUTH_TYPE = MECH_NEGOTIATE;
    MK_USER = apr_pstrdup(r->pool, output_token.value);
  
+   if (!conf->krb_append_realm && (name = strchr(MK_USER, '@')))
+      *name = '\0';
+ 
+ 
    if (conf->krb_save_credentials && delegated_cred != GSS_C_NO_CREDENTIAL)
       store_gss_creds(r, conf, (char *)output_token.value, delegated_cred);
  
